class ActiveRecord::Coders::Encryptors::AES

  attr_reader :cipher, :options

  def initialize(options = {})
    password = options[:password]
    key_length = options[:key_length] || 256
    binary = !!options[:binary]

    @cipher = ::Gibberish::AES.new(password, key_length)
    @options = { binary: binary }
  end

  def dump(data)
    cipher.encrypt(data, options) if data && !data.empty?
  end

  def load(data)
    cipher.decrypt(data, options) if data
  end
end
