class ActiveRecord::Coders::Pipeline

  attr_reader :coders

  def initialize(*coders)
    @coders = coders.flatten
  end

  def dump(data)
    coders.inject(data) do |data, coder|
      coder ? coder.dump(data) : data
    end
  end

  def load(data)
    coders.reverse.inject(data) do |data, coder|
      coder ? coder.load(data) : data
    end
  end
end
