class ActiveRecord::Coders::Serializers::Base

  class << self
    attr_accessor :load, :dump

    def serialize_with
      yield self
    end
  end

  attr_reader :options

  def initialize(options = {})
    @options = options
  end

  def load(data)
    self.class.load.call(data, options) if data
  end

  def dump(data)
    self.class.dump.call(data, options) if data
  end
end
