module ActiveRecord::Coders::Serializers
  class Marshal < Base

    serialize_with do |s|
      s.load = ->(data, options){
        if !!options[:binary]
          ::Marshal.load(data)
        else
          ::Marshal.load(::Base64.decode64(data))
        end
      }

      s.dump = ->(data, options){
        if !!options[:binary]
          ::Marshal.dump(data)
        else
          ::Base64.encode64(::Marshal.dump(data))
        end
      }
    end
  end
end
