module ActiveRecord::Coders::Serializers
  class MessagePack < Base

    serialize_with do |s|
      s.load = ->(data, options){
        if !!options[:binary]
          ::MessagePack.unpack(data)
        else
          ::MessagePack.unpack(::Base64.decode64(data))
        end
      }

      s.dump = ->(data, options){
        if !!options[:binary]
          ::MessagePack.pack(data)
        else
          ::Base64.encode64(::MessagePack.pack(data))
        end
      }
    end
  end
end
