module ActiveRecord::Coders::Serializers
  class Oj < Base

    serialize_with do |s|
      s.load = ->(data, options){
        case options[:mode]
        when :strict
          ::Oj.strict_load(data)
        when :compat, :null, :object, nil
          ::Oj.load(data)
        end
      }

      s.dump = ->(data, options){
        case options[:mode]
        when :strict, :compat, :null, :object
          ::Oj.dump(data, mode: options[:mode])
        when nil
          ::Oj.dump(data, mode: :object)
        end
      }
    end
  end
end
